#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <cstdio>
#include <queue>
#include <stack>
#include <iomanip>
#include <cstring>
#include <string>
#include <cstdlib>
#include <cmath>
#include <climits>

#define X first
#define Y second
#define MP(x, y) make_pair((x), (y))

using namespace std;

const int nmax = 200100;

int twos[nmax] = {}, minuses[nmax] = {};
int arr[nmax] = {};
int n;

int zero = -1;

int maxv = arr[1];
int maxl = 1, maxr = 1;

inline int f(int x)
{
    return x & (x-1);
}

inline int g(int x)
{
    return x | (x-1);
}

void update(int pos, int val, int fenw[])
{
    while (pos <= n)
    {
        fenw[pos] += val;
        pos = g(pos)+1;
    }
}

int sum(int r, int fenw[])
{
    int s = 0;

    while (r > 0)
    {
        s += fenw[r];
        r = f(r);

    }
    return s;
}

int sum(int l, int r, int fenw[])
{
    if (r < l)
        return INT_MIN;

    return sum(r, fenw) - sum(l-1, fenw);
}

void check(int l, int r)
{
    int v = sum(l, r, twos)+1;
    if (v == INT_MIN)
        return;
    if (sum(l, r, minuses) % 2 != 0)
        v *= -1;
    if (v > maxv )
    {
        maxv = v;
        maxl = l;
        maxr = r;
    }
}

int main()
{
    freopen("maximum.in", "r", stdin);
    freopen("maximum.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 1; i <= n; ++i) {
        scanf("%d", &arr[i]);
        if (arr[i] == 0)
            zero = i;
    }
    maxv = INT_MIN;

    for (int i = 1; i <= n; ++i)
    {
        if (abs(arr[i]) == 2)
            update(i, 1, twos);
        if (arr[i] < 0)
            update(i, 1, minuses);
    }
    int l = 1;
    int r = l;

    while (1)
    {

        while (l <= n && arr[l] == 0)
            ++l;
        r = l;
        while (r <= n && arr[r] != 0)
            ++r;

        --r;

        if (l > r || arr[r] == 0 || arr[l] == 0)
            break;


        check(l, r);

        int lminus = l;
        while (lminus < r && arr[lminus] > 0)
            ++lminus;
        check(l, lminus-1);
        check(lminus+1, r);
        int rminus = r;
        while (rminus > l && arr[rminus] > 0)
            --rminus;
        check(l, rminus-1);
        check(rminus+1, r);
        l = r+1;

    }

    if (maxv < 0 && zero != -1) {
        printf("%d %d", zero, zero);
    } else
        printf("%d %d\n", maxl, maxr);

    return 0;
}
